run("Colors...", "foreground=white background=black selection=yellow");
run("Options...", "iterations=1 count=1 black");
run("Set Measurements...", "area area_fraction display redirect=None decimal=7");

rawdir=getDirectory("User Choose Raw Data Folder");
resultdir=getDirectory("User Choose Result Data Folder");
list=getFileList(rawdir);

var method, threshold;

parameterinput();

print("RawDataFolder:	"+rawdir);
print("StainMethod	Threshold");
print(method+"	"+threshold);
print("Filename	RawMaskSize(pixel)	BrownMaskSize(pixel)	Brown%");
selectWindow("Log");
saveAs("Text", resultdir+"Summary.xls");
selectWindow("Log"); run("Close");

for(f=0;f<list.length;f++)
 {
  open(rawdir+list[f]);

  run("Median...", "radius=1");
  run("Colour Deconvolution", "vectors=["+method+"]");
  selectWindow(list[f]+"-(Colour_1)"); close();
  selectWindow(list[f]+"-(Colour_3)"); close();
  selectWindow("Colour Deconvolution"); run("Close");
  selectWindow(list[f]+"-(Colour_2)"); rename("brown");
  selectWindow(list[f]); rename("raw");

  selectWindow("brown"); run("Grays");
  run("Invert");
  run("Gaussian Blur...", "sigma=1"); run("Subtract Background...", "rolling=50");
  setAutoThreshold(threshold+" dark");
  setOption("BlackBackground", true);
  run("Convert to Mask"); run("Despeckle");
  saveAs("Tiff", resultdir+list[f]+"_BrownMask.tif"); rename("brown mask"); run("Measure");

  selectWindow("raw"); run("8-bit");
  run("Invert");
  run("Gaussian Blur...", "sigma=1");
  setAutoThreshold(threshold+" dark");
  setOption("BlackBackground", true);
  run("Convert to Mask");
  saveAs("Tiff", resultdir+list[f]+"_RawMask.tif"); rename("raw mask"); run("Measure");

  brownmask=getResult("Area", 0 ) * getResult("%Area", 0 ) / 100.0;
  rawmask=getResult("Area", 1 ) * getResult("%Area", 1 ) / 100.0;
  tmpstring=list[f]+"	"+rawmask+"	"+brownmask+"	"+brownmask/rawmask*100.0;
  File.append(tmpstring, resultdir+"Summary.xls");
  run("Clear Results"); run("Close All");
  
 }

function parameterinput()
 {
  Dialog.create("Parameter");
  Dialog.addChoice("Staining Method:", newArray("H DAB", "H&E", "H&E 2", "Feulgen Light Green", "Giemsa", "FastRed FastBlue DAB", "Methyl Green DAB", "H&E DAB", "H AEC", "Azan-Mallory", "Masson Trichrome", "Alcian blue & H", "H PAS", "Brilliant_Blue", "RGB", "CMY"));
  Dialog.addChoice("Threshold Methos:", newArray("Triangle", "Default", "Huang", "Intermodes", "IsoData", "IJ_IsoData", "Li", "MaxEntropy", "Mean", "MinError", "Minimum", "Moments", "Otsu", "Percentile", "RenyiEntropy", "Shanbhag", "Yen"));
  Dialog.show();
  method = Dialog.getChoice();
  threshold = Dialog.getChoice();	
 }
